=== debian/changelog ===
ddcui (0.3.0-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:41:51 +1100

ddcui (0.3.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:10:29 +0000

ddcui (0.3.0-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:11:24 +0000

ddcui (0.3.0-1) unstable; urgency=medium

  * New upstream release

  * debian/control
    * increment Standards-Version to 4.6.1

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Mon, 25 Jul 2022 05:00:00 -0400

ddcui (0.2.1-1) unstable; urgency=medium

  * Initial Debian release. (Closes: #1004840)

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Mon, 31 Jan 2022 05:00:00 -0400
