=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sanford Rockowitz <rockowitz@minsoft.com>
Build-Depends: debhelper      (>= 13),
               pkg-config,
               cmake,
               libglib2.0-dev,
               libxrandr-dev,
               qtbase5-dev,
               qttools5-dev,
               libddcutil4 (>= 1.2.2),
               libddcutil-dev (>= 1.2.2)
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: http://www.ddcutil.com

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GUI for ddcutil
 This package provides a graphical user interface for ddccutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.
