=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-Wall -pedantic

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs -k  CHANGELOG.md

override_dh_auto_configure:
	dh_auto_configure -- --log-level=VERBOSE
