## ddcui 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 set(ddcui_qt_version         5.5)
 set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
-set(ddcui_libddcutil_version 1.2.2)
+set(ddcui_libddcutil_version 2.0.0)
 set(cmake_build_type_default "RelWithDebInfo")
 
 message(${VERBOSE} "Required Minimum Versions:")
@@ -19,15 +19,23 @@
 message(${VERBOSE} "  ddcui_libddcutil_version:  ${ddcui_libddcutil_version}" ) 
 
 option(USE_CCACHE "Use ccache" ON)
-message(STATUS "USE_CCACHE: ${USE_CCACHE}" )
-
-string(APPEND CMAKE_MODULE_PATH  ${CMAKE_SOURCE_DIR}) 
+message(STATUS "USE_CCACHE:                ${USE_CCACHE}" )
+
+option(ASAN "Build for ASAN" OFF)
+message(STATUS "ASAN:                      ${ASAN}")
+
+option(DDCUTIL_PROJECT_DIR "Root directory of ddcutil project" OFF)
+message(STATUS "DDCUTIL_PROJECT_DIR:       ${DDCUTIL_PROJECT_DIR}"  )
+
+string(APPEND CMAKE_MODULE_PATH  ${CMAKE_SOURCE_DIR} ) 
+
 include(validate_CMAKE_BUILD_TYPE)
 
-
-project(ddcui VERSION 0.3.0 LANGUAGES C CXX)
+project(ddcui VERSION 0.5.0 LANGUAGES C CXX)
 
 message(STATUS "Build type is: ${CMAKE_BUILD_TYPE} (CMAKE_BUILD_TYPE)")
+message(${VERBOSE} "   CMAKE_C_COMPILER:               ${CMAKE_C_COMPILER}" )
+message(${VERBOSE} "   CMAKE_CXX_COMPILER:             ${CMAKE_CXX_COMPILER}" )
 message(${VERBOSE} "   CMAKE_CXX_FLAGS:                ${CMAKE_CXX_FLAGS}" )
 message(${VERBOSE} "   CMAKE_C_FLAGS:                  ${CMAKE_C_FLAGS}" )
 message(${VERBOSE} "   CMAKE_CXX_FLAGS_DEBUG:          ${CMAKE_CXX_FLAGS_DEBUG}" )
@@ -44,6 +52,21 @@
 message(STATUS "Source directory: ${CMAKE_SOURCE_DIR} (CMAKE_SOURCE_DIR)" )
 message(STATUS "Build directory:  ${CMAKE_BINARY_DIR} (CMAKE_BINARY_DIR)" )
 
+  execute_process(
+      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+      COMMAND git branch --show-current 2>/dev/null
+      OUTPUT_VARIABLE DDCUI_GIT_BRANCH
+      RESULT_VARIABLE GIT_CMD_STATUS
+   )
+   # message (${VERBOSE} " result_variable: ${GIT_CMD_STATUS}")
+   if (${GIT_CMD_STATUS} STREQUAL "0")
+      string(LENGTH ${DDCUI_GIT_BRANCH} N)
+      math(EXPR lastpos "${N}-1")
+      string(SUBSTRING ${DDCUI_GIT_BRANCH} 0 ${lastpos} DDCUI_GIT_BRANCH)
+      message( ${VERBOSE} "ddcui git branch:   ${DDCUI_GIT_BRANCH}")
+   else() 
+      message( ${VERBOSE} "ddcui source is not managed by git")
+   endif()
 if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} ) 
    message(WARNING "Attempting to build in source directory.")
    if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
@@ -63,6 +86,11 @@
 # set (coverity_cflags --type_traits_helpers)
 # set (coverity_cflags --no_predefined_feature_test_macros)
 # set (COVERITY_DUMMIES OFF)
+
+if (ASAN)
+   set (asan_flags -g -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer)
+   set (ASAN_LIBRARY asan)
+endif()
 
 message(${VERBOSE} "Significant environment variables:")
 message(${VERBOSE} "  INCLUDE:                  $ENV{INCLUDE}")
@@ -102,11 +130,42 @@
 
 find_package (PkgConfig REQUIRED )
 pkg_check_modules(GLIB2 REQUIRED glib-2.0>=${ddcui_glib_version})
-pkg_check_modules(DDCUTIL REQUIRED ddcutil>=${ddcui_libddcutil_version})
-# set(DDCUTIL_LIBRARY_DIRS /usr/lib/x86_64-linux-gnu/)   # hack for testing
+
+if ( (DDCUTIL_PROJECT_DIR STREQUAL "OFF")) 
+   message( ${VERBOSE} "Locating ddcutil files using pkg_check_modules")
+   pkg_check_modules(DDCUTIL REQUIRED ddcutil>=${ddcui_libddcutil_version})
+else()
+   message( ${VERBOSE} "Using ddcutil files from ${DDCUTIL_PROJECT_DIR}")
+   string(LENGTH ${DDCUTIL_PROJECT_DIR} N)
+   math(EXPR lastpos "${N}-1")
+   string(SUBSTRING ${DDCUTIL_PROJECT_DIR} ${lastpos} 1 CH)
+   if ( ( ${CH} STREQUAL /) )
+      string(SUBSTRING ${DDCUTIL_PROJECT_DIR} 0 ${lastpos} DDCUTIL_PROJECT_DIR)
+      message( ${VERBOSE} "Adjusted DDCUTIL_PROJECT_DIR:  ${DDCUTIL_PROJECT_DIR}")
+   endif()
+   set(DDCUTIL_INCLUDE_DIRS ${DDCUTIL_PROJECT_DIR}/src/public)
+   set(DDCUTIL_LIBRARY_DIRS ${DDCUTIL_PROJECT_DIR}/src/.libs)
+   set(DDCUTIL_LIBRARIES ddcutil)
+   execute_process(
+      WORKING_DIRECTORY ${DDCUTIL_PROJECT_DIR}
+      COMMAND git branch --show-current
+      OUTPUT_VARIABLE DDCUTIL_GIT_BRANCH
+      RESULT_VARIABLE GIT_CMD_STATUS
+   )
+   if (${GIT_CMD_STATUS} STREQUAL "0")
+      string(LENGTH ${DDCUTIL_GIT_BRANCH} N)
+      math(EXPR lastpos "${N}-1")
+      string(SUBSTRING ${DDCUTIL_GIT_BRANCH} 0 ${lastpos} DDCUTIL_GIT_BRANCH)
+      message( ${VERBOSE} "ddcutil git branch:   ${DDCUTIL_GIT_BRANCH}")
+   else() 
+      message( ${VERBOSE} "ddcui source is not managed by git")
+   endif()
+endif()
+
 message( ${VERBOSE} "Set by pkg-config:" )
 message( ${VERBOSE} "  GLIB2_INCLUDE_DIRS:       ${GLIB2_INCLUDE_DIRS}"   )
 message( ${VERBOSE} "  GLIB2_LIBRARIES:          ${GLIB2_LIBRARIES}"      )
+
 message( ${VERBOSE} "  DDCUTIL_INCLUDE_DIRS:     ${DDCUTIL_INCLUDE_DIRS}" )
 message( ${VERBOSE} "  DDCUTIL_LIBRARY_DIRS:     ${DDCUTIL_LIBRARY_DIRS}" )
 message( ${VERBOSE} "  DDCUTIL_LIBRARIES:        ${DDCUTIL_LIBRARIES}"    )
@@ -116,15 +175,17 @@
 set(SOURCES
     src/c_util/data_structures.c
     src/c_util/ddcutil_config_file.c
+    src/c_util/debug_util.c
+    src/c_util/error_info.c
     src/c_util/file_util_base.c
     src/c_util/glib_util.c
-    src/c_util/debug_util.c
     src/c_util/report_util.c
     src/c_util/simple_ini_file.c
     src/c_util/string_util.c
     src/c_util/xdg_util.c
 
-    src/base/core.cpp 
+    src/base/ddcui_core_aux.c
+    src/base/ddcui_core.cpp 
     src/base/ddca_utils.cpp 
     src/base/ddcui_parms.cpp
     src/base/feature_list.c
@@ -211,17 +272,20 @@
 
 # -Wno-format-pedantic -Wno-sign-compare -std=c++20 -Wno-format -pedantic -Wextra -Wall
 # set(more_options -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-non-pod-varargs  )
-target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags})
+target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags} ${asan_flags})
 # add_compile_options(-Og -H V=1)
 
 # redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
 #            ${Qt5Help_INCLUDE_DIRS} is a superset of them all 
-target_include_directories(ddcui SYSTEM PRIVATE 
+target_include_directories(ddcui SYSTEM PRIVATE
                                  ${Qt5Help_INCLUDE_DIRS}
                                  ${GLIB2_INCLUDE_DIRS} 
                                  ${DDCUTIL_INCLUDE_DIRS})
 
 target_include_directories(ddcui PRIVATE src)
+
+# Use the Widgets module from Qt 5.
+target_link_libraries(ddcui ${ASAN_LIBRARY} Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})
 
 get_property(dirs TARGET ddcui PROPERTY INCLUDE_DIRECTORIES)
 message( ${VERBOSE} "INCLUDE_DIRECTORIES:     ${dirs}" )
@@ -230,62 +294,7 @@
   message(${VERBOSE} "  ${d}")
 endforeach()
 
-# Use the Widgets module from Qt 5.
-target_link_libraries(ddcui Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})
-
-
-### make clean
-
-# ADDITIONAL_MAKE_CLEAN_FILES(  ... )
-
-
-### make install
-
-# define GNU standard installation directories
-include(GNUInstallDirs)
-message( ${VERBOSE} "GNU installation directories:")
-message( ${VERBOSE} "  CMAKE_INSTALL_BINDIR:        ${CMAKE_INSTALL_BINDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_PREFIX:        ${CMAKE_INSTALL_PREFIX}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_DATATROOTDIR:  ${CMAKE_INSTALL_DATAROOTDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_SYSCONFDIR:    ${CMAKE_INSTALL_SYSCONFDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_LIBDIR:        ${CMAKE_INSTALL_LIBDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_LIBEXECDIR:    ${CMAKE_INSTALL_LIBEXECDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_INCLUDEDIR:    ${CMAKE_INSTALL_INCLUDEDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_INFODIR:       ${CMAKE_INSTALL_INFODIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_MANDIR:        ${CMAKE_INSTALL_MANDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_DOCDIR:        ${CMAKE_INSTALL_DOCDIR}" )
-
-# Special handling for openSuse and SLE. 
-# Normally, documentation files are stored in directory /usr/share/doc/ddcui. 
-# The value of CMAKE_INSTALL_DOCDIR is "share/doc/ddcui".  However, on SuSE
-# systems, doc files are instead stored in directory /usr/share/doc/packages/ddcui.
-# However, CMAKE_INSTALL_DOCDIR is still set to "share/doc/ddcui". 
-# The following code tries to determine if we're running on a system where
-# the value of CMAKE_INSTALL_DOCDIR needs to be changed to "share/doc/packages/ddcui". 
-# For SuSe (and Fedora) file /etc/os-release is automatically installed
-# from the default packages.  However, for SLE it is not, so the os-release check
-# is not possible. Instead, a heuristic test is performed.
-
-set(suse_special_case FALSE)
-if(EXISTS "/etc/os-release")
-   message(STATUS "File /etc/os-release found")
-   file(STRINGS "/etc/os-release" id_line REGEX "^ID=(.*)$") 
-   string(STRIP ${id_line} id_line)
-   
-   # Testcases:
-   # set(id_line "ID=\"opensuse-leap\"")
-   # set(id_line "ID=opensuse-leap")
-   # message(STATUS "id_line: |${id_line}|")
-   
-   string(SUBSTRING ${id_line} 3 -1 distro_name0)
-   string(SUBSTRING ${distro_name0} 0 1 ch)
-   if (ch STREQUAL "\"") 
-      string(LENGTH ${distro_name0} len)
-      math(EXPR l2 "${len}-2")
-      string(SUBSTRING ${distro_name0} 1 ${l2} distro_name0)
-   endif()
-   string(SUBSTRING ${distro_name0} 0 8 distro_name)
-   message(STATUS "Distribution: distro_name = |${distro_name}|")
-   if( distro_name STREQUAL "opensuse" )
-      # message(STATUS "distro_name matches opensuse") 
-      set(suse_special_case TRUE)
+get_property(dirs TARGET ddcui PROPERTY LINK_DIRECTORIES)
+message( ${VERBOSE} "LINK_DIRECTORIES:     ${dirs}" )
+message( ${VERBOSE} "Expanded:" )
+foreach(d ${dirs})
