=== debian/changelog ===
ddcui (0.5.0-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * depends on libddcutil5

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 17 Jan 2024 05:00:00 -0400

ddcui (0.4.1-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * bump standards version to 4.6.2

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 27 Sep 2023 05:00:00 -0400

ddcui (0.3.0-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * bump standards version to 4.6.1

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 23 Jul 2022 05:00:00 -0400

ddcui (0.2.1-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Fri, 28 Jan 2022 05:00:00 -0400

ddcui (0.2.0-1) focal; urgency=low

  * Initial beta release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sun, 31 Jan 2021 05:00:00 -0400

ddcui (0.1.1-2) focal; urgency=low

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 13 Jun 2020 05:00:00 -0400
