=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Sanford Rockowitz <rockowitz@minsoft.com>
Build-Depends: debhelper      (>= 10),
               pkg-config,
               cmake          (>= 3.10),
               qtbase5-dev    (>= 5.5),
               qttools5-dev   (>= 5.5),
               libglib2.0-dev (>= 2.40),
               libxrandr-dev,
               libddcutil5    (>= 2.1.0),
               libddcutil-dev (>= 2.1.0)
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://www.ddcutil.com

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqt5concurrent5  (>= 5.5),
         libqt5core5a       (>= 5.5),
         libqt5gui5         (>= 5.5),
         libqt5widgets5     (>= 5.5),
         libddcutil5        (>= 2.0.0)
Description: Control monitor settings
 Graphical User Interface for ddcutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.
