=== debian/changelog ===
ddcui (0.5.3-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 08 Feb 2024 05:00:00 -0400

ddcui (0.5.2-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 27 Jan 2024 05:00:00 -0400
