=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
          libqt5core5a       (>= 5.5),
          libqt5gui5         (>= 5.5),
          libqt5widgets5     (>= 5.5),
-         libddcutil5        (>= 2.0.0)
+         libddcutil5        (>= 2.1.0)
 Description: Control monitor settings
  Graphical User Interface for ddcutil.
  .
