## ddcui 0.5.4

=== debian/changelog ===
ddcui (0.5.4-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 14 Dec 2024 00:53:16 -0800

ddcui (0.5.4-2) unstable; urgency=medium

  * 'd/control': Adoption, add myself as maintainer. (Closes: #1080173)
  * Add Debian Continuous Integration (CI) file: 'd/salsa-ci.yml'.
  * 'd/rules': Add DH_VERBOSE, but have disabled by default.

 -- Phil Wyett <philip.wyett@kathenas.org>  Tue, 10 Sep 2024 15:09:51 +0100

ddcui (0.5.4-1) unstable; urgency=medium

  * QA upload.
  * Package orphaned.
  * New upstream version 0.5.4.
  * Remove 'd/compat'.
  * 'd/control':
    - Change maintainer to QA group.
    - Use HTTPS for 'Homepage'.
    - Update 'Standards-Version' to 4.7.0, no changes required.
    - Remove versioned build dependencies.
    - Remove 'libddcutil4' build dependency.
    - Update obsolete build dependency 'pkg-config => pkgconf'.
    - Use 'debhelper-compat' 13.
    - Add Vcs fields.
  * 'd/rules' - Remove 'override_dh_auto_configure' block.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sun, 08 Sep 2024 10:46:47 +0100
