## ddcui 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-set(ddcui_version  0.5.3)
+set(ddcui_version  0.6.0)
 message(STATUS "ddcui_version:  ${ddcui_version}")
 
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.15)
 
 message(STATUS "cmake version: ${CMAKE_VERSION}")
 # message(VERBOSE) requires cmake 3.15
@@ -13,8 +13,8 @@
 
 set(ddcui_qt5_min_version    5.5)
 set(ddcui_qt6_min_version    6.1)
-set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
-set(ddcui_libddcutil_version 2.1.0)
+set(ddcui_glib_version       2.60) 
+set(ddcui_libddcutil_version 2.2.0)
 set(cmake_build_type_default "RelWithDebInfo")
 
 message(${VERBOSE} "Required Minimum Versions:")
@@ -192,15 +192,21 @@
 configure_file(cconfig.h.in config.h)
 
 set(SOURCES
+    src/c_util/common_inlines.h
+    src/c_util/common_printf_formats.h
+    src/c_util/backtrace.c
     src/c_util/data_structures.c
     src/c_util/ddcutil_config_file.c
     src/c_util/debug_util.c
     src/c_util/error_info.c
     src/c_util/file_util_base.c
     src/c_util/glib_util.c
+    src/c_util/msg_util.c
     src/c_util/report_util.c
     src/c_util/simple_ini_file.c
     src/c_util/string_util.c
+    src/c_util/traced_function_stack.c
+    src/c_util/timestamp.c
     src/c_util/xdg_util.c
 
     src/base/ddcui_core_aux.c
@@ -268,6 +274,7 @@
     src/main/mainwindow_ui.cpp
     src/main/monitor.cpp 
     src/main/msgbox_thread.cpp
+	src/main/callback_manager.cpp
 )
 
 # file(GLOB dummy_SOURCES src/dummies/*.cpp)
@@ -292,7 +299,3 @@
 # -Wno-format-pedantic -Wno-sign-compare -std=c++20 -Wno-format -pedantic -Wextra -Wall
 # set(more_options -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-non-pod-varargs  )
 target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags} ${asan_flags})
-# add_compile_options(-Og -H V=1)
-
-# redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
-#            ${Qt5Help_INCLUDE_DIRS} is a superset of them all
