=== debian/changelog ===
ddcui (0.6.0-5) unstable; urgency=medium

  * 'debian/watch':
    - Make 'Version: 5' its own paragraph.

 -- Phil Wyett <philip.wyett@kathenas.org>  Tue, 09 Sep 2025 12:33:37 +0100

ddcui (0.6.0-4) unstable; urgency=medium

  * 'debian/changelog'
    - Fix typo.

 -- Phil Wyett <philip.wyett@kathenas.org>  Wed, 03 Sep 2025 10:04:26 +0100

ddcui (0.6.0-3) unstable; urgency=medium

  * 'debian/control':
    - Remove not need 'Rules-Requires-Root: no'.
    - Remove version requirement on 'libddcutil-dev' 'Build-Depends'.

 -- Phil Wyett <philip.wyett@kathenas.org>  Fri, 29 Aug 2025 21:39:34 +0100

ddcui (0.6.0-2) unstable; urgency=medium

  * 'debian/control':
    - Update to 'Standards-Version' 4.7.2, no changes required.
  * 'debian/watch':
    - Update to version 5.

 -- Phil Wyett <philip.wyett@kathenas.org>  Thu, 28 Aug 2025 11:16:17 +0100

ddcui (0.6.0-1) unstable; urgency=medium

  * New upstream release, 0.6.0.
  * 'd/control':
    - Add minimum version for 'libddcutil-dev' 'Build-Depends'.
    - Update 'Standards-Version' to 4.7.1, no changes required.
  * 'd/copyright':
    - Update year for my entry in 'Files: debian/*' section.
  * Add simple 'd/gbp.conf' to start us off.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sat, 22 Feb 2025 19:01:55 +0000
