=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Phil Wyett <philip.wyett@kathenas.org>
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               cmake,
               libglib2.0-dev,
               libxrandr-dev,
               qtbase5-dev,
               qttools5-dev,
               libddcutil-dev
Standards-Version: 4.7.2
Homepage: https://www.ddcutil.com
Vcs-Git: https://salsa.debian.org/debian/ddcui.git
Vcs-Browser: https://salsa.debian.org/debian/ddcui

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GUI for ddcutil
 This package provides a graphical user interface for ddccutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.
