=== debian/watch ===
Version: 5

Template: Github
Owner: rockowitz
Project: ddcui
